/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <phk@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   Poul-Henning Kamp
 * ----------------------------------------------------------------------------
 * $Id: configkit_int.h,v 1.6 2005/10/31 08:01:14 phk Exp $
 *
 * Parse the configuration and get things going.
 *
 */
#ifndef _CONFIGKIT_INT_H_
#define _CONFIGKIT_INT_H_ 1


struct ck_tree {
	int				nnodes;
	struct __ck_node		**nodes;
};

struct __ck_node {
	const char			*word;
	ck_func_t			*func;
	ck_func_t			*show;
	const char			*desc;
};

int __ck_enum(CK_ARG, const char ***dest, int idx, const char **table);
int __ck_word(CK_ARG, const char ***dest, int idx);
int __ck_uint(CK_ARG, unsigned **dest, int idx);
int __ck_real(CK_ARG, double **dest, int idx);
int __ck_follow(CK_ARG, struct __ck_node **nodes);
int __ck_ellipsis(CK_ARG, char ***dest, int idx);

/*
 * Config execution/traversal (config.c)
 */
int __ck_call(CK_ARG);

int __ck_walk_word(CK_ARG, struct ck_instancehead *, struct __ck_node **nodes);
int __ck_walk_uint(CK_ARG, struct ck_instancehead *, struct __ck_node **nodes);

#define HERE()	printf("HERE: %s:%d %s()\n", __FILE__, __LINE__, __func__)

#endif /* _CONFIGKIT_INT_H_ */
